/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.tref.liferay.mapit.map.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

/**
 * The base model interface for the PluginPortletPreferences service. Represents a row in the &quot;MI_Map_PluginPortletPrefs&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesImpl}.
 * </p>
 *
 * @author
 * @see PluginPortletPreferences
 * @see it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesImpl
 * @see it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl
 * @generated
 */
public interface PluginPortletPreferencesModel extends BaseModel<PluginPortletPreferences> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a plugin portlet preferences model instance should use the {@link PluginPortletPreferences} interface instead.
	 */

	/**
	 * Returns the primary key of this plugin portlet preferences.
	 *
	 * @return the primary key of this plugin portlet preferences
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this plugin portlet preferences.
	 *
	 * @param primaryKey the primary key of this plugin portlet preferences
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the plugin portlet preferences ID of this plugin portlet preferences.
	 *
	 * @return the plugin portlet preferences ID of this plugin portlet preferences
	 */
	public long getPluginPortletPreferencesId();

	/**
	 * Sets the plugin portlet preferences ID of this plugin portlet preferences.
	 *
	 * @param pluginPortletPreferencesId the plugin portlet preferences ID of this plugin portlet preferences
	 */
	public void setPluginPortletPreferencesId(long pluginPortletPreferencesId);

	/**
	 * Returns the owner ID of this plugin portlet preferences.
	 *
	 * @return the owner ID of this plugin portlet preferences
	 */
	public long getOwnerId();

	/**
	 * Sets the owner ID of this plugin portlet preferences.
	 *
	 * @param ownerId the owner ID of this plugin portlet preferences
	 */
	public void setOwnerId(long ownerId);

	/**
	 * Returns the owner type of this plugin portlet preferences.
	 *
	 * @return the owner type of this plugin portlet preferences
	 */
	public int getOwnerType();

	/**
	 * Sets the owner type of this plugin portlet preferences.
	 *
	 * @param ownerType the owner type of this plugin portlet preferences
	 */
	public void setOwnerType(int ownerType);

	/**
	 * Returns the plid of this plugin portlet preferences.
	 *
	 * @return the plid of this plugin portlet preferences
	 */
	public long getPlid();

	/**
	 * Sets the plid of this plugin portlet preferences.
	 *
	 * @param plid the plid of this plugin portlet preferences
	 */
	public void setPlid(long plid);

	/**
	 * Returns the portlet ID of this plugin portlet preferences.
	 *
	 * @return the portlet ID of this plugin portlet preferences
	 */
	@AutoEscape
	public String getPortletId();

	/**
	 * Sets the portlet ID of this plugin portlet preferences.
	 *
	 * @param portletId the portlet ID of this plugin portlet preferences
	 */
	public void setPortletId(String portletId);

	/**
	 * Returns the plugin of this plugin portlet preferences.
	 *
	 * @return the plugin of this plugin portlet preferences
	 */
	@AutoEscape
	public String getPlugin();

	/**
	 * Sets the plugin of this plugin portlet preferences.
	 *
	 * @param plugin the plugin of this plugin portlet preferences
	 */
	public void setPlugin(String plugin);

	/**
	 * Returns the preferences of this plugin portlet preferences.
	 *
	 * @return the preferences of this plugin portlet preferences
	 */
	@AutoEscape
	public String getPreferences();

	/**
	 * Sets the preferences of this plugin portlet preferences.
	 *
	 * @param preferences the preferences of this plugin portlet preferences
	 */
	public void setPreferences(String preferences);

	@Override
	public boolean isNew();

	@Override
	public void setNew(boolean n);

	@Override
	public boolean isCachedModel();

	@Override
	public void setCachedModel(boolean cachedModel);

	@Override
	public boolean isEscapedModel();

	@Override
	public Serializable getPrimaryKeyObj();

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	@Override
	public ExpandoBridge getExpandoBridge();

	@Override
	public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

	@Override
	public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	@Override
	public Object clone();

	@Override
	public int compareTo(PluginPortletPreferences pluginPortletPreferences);

	@Override
	public int hashCode();

	@Override
	public CacheModel<PluginPortletPreferences> toCacheModel();

	@Override
	public PluginPortletPreferences toEscapedModel();

	@Override
	public PluginPortletPreferences toUnescapedModel();

	@Override
	public String toString();

	@Override
	public String toXmlString();
}